import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;

public class MainClass {

    public static void completed() {
        System.out.println("Completed");
    }

    private static String checkFile(final String path) throws Exception {
        String ret = path;
        if (path.charAt(0) == '.') {
            ret = new File(MainClass.class.getProtectionDomain().getCodeSource().getLocation().toURI()).getParentFile() + path.substring(1);
        }
        return ret;
    }

    public static void main(String[] args) throws Exception {

        String paraData = checkFile(args[0]);
        int paraNumTest = 20;
        int popSize = 100;
        int maxIter = 200;

        if (args.length > 1) {
            paraNumTest = Integer.valueOf(args[1]);
        }
        if (args.length > 2) {
            popSize = Integer.valueOf(args[2]);
        }
        if (args.length > 3) {
            maxIter = Integer.valueOf(args[3]);
        }

        StringBuilder sb;
        String dsPath = paraData.substring(0, paraData.lastIndexOf('/') + 1);

        String logId = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
        File logFolder = new File(dsPath + logId);
        while (logFolder.exists()) {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException ex) {
                Thread.currentThread().interrupt();
            }
            logId = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
            logFolder = new File(dsPath + logId);
        }
        logFolder.mkdir();
        String logPath = dsPath + logId + "/";

        for (int i = 0; i < paraNumTest; i++) {
            sb = new StringBuilder();
            sb.append(logPath).append("test-").append(i).append(".txt");
            String logFile = sb.toString();
            System.out.println(paraData);
            System.out.println(logFile);
            FeatureSelection fs = new FeatureSelection(paraData, logFile);
            fs.setMaxIter(maxIter);
            fs.setPopSize(popSize);
            fs.addJob("PSO", true, true);
            fs.addJob("CSO", true, true);
            fs.addJob("Xue1", true, true);
            fs.addJob("Xue2", true, true);
            fs.addJob("Xue3", true, true);
            fs.addJob("Xue4", true, true);
            new Thread(fs, logFile).start();
        }
    }
}
