package org.tidestudio.utils;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.List;

public class TideIOUtils {
    // Array to String
    public static String arrayToString(final int x[]) {
        StringBuffer bs = new StringBuffer();
        int len = x.length;
        bs.append(len).append(":{");
        for (int i = 0; i < len; i++) {
            bs.append(x[i]);
            if (i < len - 1) {
                bs.append(", ");
            }
        }
        bs.append("}");
        return bs.toString();
    }

    public static String arrayToString(final double x[]) {
        return arrayToString(x, 6);
    }

    public static String arrayToString(final double x[], final int fractionDigits) {
        DecimalFormat df = new DecimalFormat();
        df.setMaximumFractionDigits(fractionDigits);
        df.setMinimumFractionDigits(fractionDigits);
        StringBuffer bs = new StringBuffer();
        int len = x.length;
        bs.append(len).append(":{");
        for (int i = 0; i < len; i++) {
            bs.append(df.format(x[i]));
            if (i < len - 1) {
                bs.append(", ");
            }
        }
        bs.append("}");
        return bs.toString();
    }

    public static String listListToString(final List<? extends List<? extends Number>> something) {
        DecimalFormat df = new DecimalFormat();
        df.setMaximumFractionDigits(6);
        df.setMinimumFractionDigits(6);
        StringBuilder sb = new StringBuilder();
        int len = something.size();
        sb.append(len).append(":{");
        for (int i = 0; i < len; i++) {
            List<?> sub = something.get(i);
            int subLen = sub.size();
            sb.append(subLen).append(":{");
            for (int j = 0; j < subLen; j++) {
                if (sub.get(j).getClass() == Integer.class) {
                    sb.append(sub.get(j));
                } else {
                    sb.append(df.format(sub.get(j)));
                }
                if (j < subLen - 1) {
                    sb.append(", ");
                }
            }
            sb.append("}");
            if (i < len - 1) {
                sb.append(", ");
            }
        }
        sb.append("}");
        return sb.toString();
    }

    // Save Log
    public static void saveLog(final String path, final String s) {
        if (path != null) {
            try (PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(path, true)))) {
                out.println(s);
            } catch (IOException e) {
                System.err.println(e);
            }
        }
        System.out.println(s);
    }
}
